diff --git a/tensorflow/contrib/resampler/python/ops/resampler_ops_test.py b/tensorflow/contrib/resampler/python/ops/resampler_ops_test.py
index e30e7255fac..acaa978e258 100644
--- a/tensorflow/contrib/resampler/python/ops/resampler_ops_test.py
+++ b/tensorflow/contrib/resampler/python/ops/resampler_ops_test.py
@@ -20,7 +20,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib import resampler
 from tensorflow.python.framework import constant_op
@@ -147,8 +146,8 @@ class ResamplerTest(test.TestCase):
 
     # Generate reference output via bilinear interpolation in numpy
     reference_output = np.zeros_like(out)
-    for batch in xrange(batch_size):
-      for c in xrange(data_channels):
+    for batch in range(batch_size):
+      for c in range(data_channels):
         reference_output[batch, :, :, c] = _bilinearly_interpolate(
             data[batch, :, :, c],
             warp[batch, :, :, 0],
diff --git a/tensorflow/contrib/session_bundle/gc.py b/tensorflow/contrib/session_bundle/gc.py
index 4a9adcf4838..5d6c8e0123d 100644
--- a/tensorflow/contrib/session_bundle/gc.py
+++ b/tensorflow/contrib/session_bundle/gc.py
@@ -33,7 +33,7 @@ Note that functions should always return a sorted list.
 For example,
   base_dir = "/tmp"
   # create the directories
-  for e in xrange(10):
+  for e in range(10):
     os.mkdir("%s/%d" % (base_dir, e), 0o755)
 
   # create a simple parser that pulls the export_version from the directory
diff --git a/tensorflow/contrib/session_bundle/gc_test.py b/tensorflow/contrib/session_bundle/gc_test.py
index 02725bb1cbb..f225f48cf21 100644
--- a/tensorflow/contrib/session_bundle/gc_test.py
+++ b/tensorflow/contrib/session_bundle/gc_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import os
 import re
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.session_bundle import gc
 from tensorflow.python.framework import test_util
@@ -75,7 +74,7 @@ class GcTest(test_util.TensorFlowTestCase):
 
   def testUnion(self):
     paths = []
-    for i in xrange(10):
+    for i in range(10):
       paths.append(gc.Path("/foo", i))
     f = gc.union(gc.largest_export_versions(3), gc.mod_export_version(3))
     self.assertEquals(
@@ -97,7 +96,7 @@ class GcTest(test_util.TensorFlowTestCase):
   def testPathsWithParse(self):
     base_dir = os.path.join(test.get_temp_dir(), "paths_parse")
     self.assertFalse(gfile.Exists(base_dir))
-    for p in xrange(3):
+    for p in range(3):
       gfile.MakeDirs(os.path.join(base_dir, "%d" % p))
     # add a base_directory to ignore
     gfile.MakeDirs(os.path.join(base_dir, "ignore"))
diff --git a/tensorflow/core/kernels/BUILD b/tensorflow/core/kernels/BUILD
index 22d2facf5ca..de3d5d34760 100644
--- a/tensorflow/core/kernels/BUILD
+++ b/tensorflow/core/kernels/BUILD
@@ -1339,8 +1339,6 @@ tf_kernel_library(
     ],
     deps = if_cuda_or_rocm([
         ":cuda_solvers",
-    ]) + if_cuda([
-        "@cub_archive//:cub",
     ]) + if_rocm([
         "@rocprim_archive//:rocprim",
     ]) + ARRAY_DEPS,
@@ -2502,7 +2500,7 @@ tf_kernel_library(
     deps = DYNAMIC_DEPS + [
         ":fill_functor",
         ":gather_functor",
-    ] + if_cuda(["@cub_archive//:cub"]) + if_rocm([
+    ] + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
 )
@@ -2905,7 +2903,7 @@ tf_kernel_library(
 tf_kernel_library(
     name = "non_max_suppression_op",
     prefix = "non_max_suppression_op",
-    deps = IMAGE_DEPS + if_cuda(["@cub_archive//:cub"]),
+    deps = IMAGE_DEPS,
 )
 
 tf_kernel_library(
@@ -3823,9 +3821,7 @@ tf_kernel_library(
     name = "reduction_ops",
     gpu_srcs = ["reduction_gpu_kernels.cu.h"],
     prefix = "reduction_ops",
-    deps = MATH_DEPS + [":transpose_functor"] + if_cuda([
-        "@cub_archive//:cub",
-    ]) + if_rocm([
+    deps = MATH_DEPS + [":transpose_functor"] + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
 )
@@ -3850,9 +3846,7 @@ tf_kernel_library(
         "scan_ops_gpu_half.cu.cc",
         "scan_ops_gpu_int.cu.cc",
     ],
-    deps = MATH_DEPS + if_cuda([
-        "@cub_archive//:cub",
-    ]) + if_rocm([
+    deps = MATH_DEPS + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
 )
@@ -4284,7 +4278,6 @@ tf_kernel_library(
         "//tensorflow/core:framework",
         "//tensorflow/core:lib",
     ] + if_cuda([
-        "@cub_archive//:cub",
         "@local_config_cuda//cuda:cudnn_header",
     ]) + if_rocm([
         "@rocprim_archive//:rocprim",
@@ -4373,7 +4366,6 @@ tf_kernel_library(
     ] + if_cuda_or_rocm([
         ":reduction_ops",
     ]) + if_cuda([
-        "@cub_archive//:cub",
         "//tensorflow/core:stream_executor",
         "//tensorflow/stream_executor/cuda:cuda_stream",
     ]) + if_rocm([
@@ -4415,8 +4407,6 @@ tf_kernel_library(
     prefix = "softmax_op",
     deps = NN_DEPS + if_cuda_or_rocm([
         ":reduction_ops",
-    ]) + if_cuda([
-        "@cub_archive//:cub",
     ]) + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
@@ -4451,9 +4441,7 @@ tf_kernel_library(
         "topk_op_gpu_int8.cu.cc",
         "topk_op_gpu_uint8.cu.cc",
     ],
-    deps = NN_DEPS + if_cuda([
-        "@cub_archive//:cub",
-    ]) + if_rocm([
+    deps = NN_DEPS + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
 )
@@ -4478,7 +4466,7 @@ tf_kernel_library(
         "//tensorflow/core:lib",
         "//tensorflow/core:lib_internal",
         "//third_party/eigen3",
-    ] + if_cuda(["@cub_archive//:cub"]) + if_rocm([
+    ] + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
 )
@@ -4491,7 +4479,7 @@ tf_kernel_library(
         "//tensorflow/core:lib",
         "//tensorflow/core:lib_internal",
         "//third_party/eigen3",
-    ] + if_cuda(["@cub_archive//:cub"]) + if_rocm([
+    ] + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
 )
@@ -4506,7 +4494,7 @@ tf_kernel_library(
         "//tensorflow/core:lib",
         "//tensorflow/core:lib_internal",
         "//tensorflow/core:nn_grad",
-    ] + if_cuda(["@cub_archive//:cub"]) + if_rocm([
+    ] + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
 )
@@ -5084,8 +5072,6 @@ tf_kernel_library(
         "//third_party/eigen3",
     ] + if_cuda_or_rocm([
         ":reduction_ops",
-    ]) + if_cuda([
-        "@cub_archive//:cub",
     ]) + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
@@ -5655,8 +5641,6 @@ tf_kernel_library(
         "//tensorflow/core:lib_internal",
     ] + if_cuda_or_rocm([
         ":reduction_ops",
-    ]) + if_cuda([
-        "@cub_archive//:cub",
     ]) + if_rocm([
         "@rocprim_archive//:rocprim",
     ]),
diff --git a/tensorflow/core/kernels/bincount_op_gpu.cu.cc b/tensorflow/core/kernels/bincount_op_gpu.cu.cc
index a2ad9cacf12..303056387b3 100644
--- a/tensorflow/core/kernels/bincount_op_gpu.cu.cc
+++ b/tensorflow/core/kernels/bincount_op_gpu.cu.cc
@@ -18,7 +18,7 @@ limitations under the License.
 #define EIGEN_USE_GPU
 
 #if GOOGLE_CUDA
-#include "third_party/cub/device/device_histogram.cuh"
+#include "third_party/gpus/cuda/include/cub/cub.cuh"
 #elif TENSORFLOW_USE_ROCM
 #include "external/rocprim_archive/hipcub/include/hipcub/hipcub.hpp"
 #endif
diff --git a/tensorflow/core/kernels/cuda_sparse.cc b/tensorflow/core/kernels/cuda_sparse.cc
index dff78bc9c7e..04d9e7294f0 100644
--- a/tensorflow/core/kernels/cuda_sparse.cc
+++ b/tensorflow/core/kernels/cuda_sparse.cc
@@ -209,7 +209,7 @@ static inline Status GtsvImpl(SparseFn op, cusparseHandle_t cusparse_handle,
                     dl, d, du, B, ldb);                                      \
   }
 
-TF_CALL_LAPACK_TYPES(GTSV_INSTANCE);
+//TF_CALL_LAPACK_TYPES(GTSV_INSTANCE);
 
 #define GTSV_NO_PIVOT_INSTANCE(Scalar, sparse_prefix)                          \
   template <>                                                                  \
@@ -221,7 +221,7 @@ TF_CALL_LAPACK_TYPES(GTSV_INSTANCE);
                     m, n, dl, d, du, B, ldb);                                  \
   }
 
-TF_CALL_LAPACK_TYPES(GTSV_NO_PIVOT_INSTANCE);
+//TF_CALL_LAPACK_TYPES(GTSV_NO_PIVOT_INSTANCE);
 
 template <typename Scalar, typename SparseFn>
 static inline Status GtsvStridedBatchImpl(SparseFn op,
@@ -247,7 +247,7 @@ static inline Status GtsvStridedBatchImpl(SparseFn op,
                                 batchCount, batchStride);                    \
   }
 
-TF_CALL_LAPACK_TYPES(GTSV_STRIDED_BATCH_INSTANCE);
+//TF_CALL_LAPACK_TYPES(GTSV_STRIDED_BATCH_INSTANCE);
 
 template <typename Scalar, typename SparseFn>
 static inline Status Gtsv2Impl(SparseFn op, cusparseHandle_t cusparse_handle,
diff --git a/tensorflow/core/kernels/dynamic_partition_op_gpu.cu.cc b/tensorflow/core/kernels/dynamic_partition_op_gpu.cu.cc
index 7fe519b063c..49f31718396 100644
--- a/tensorflow/core/kernels/dynamic_partition_op_gpu.cu.cc
+++ b/tensorflow/core/kernels/dynamic_partition_op_gpu.cu.cc
@@ -36,10 +36,7 @@ limitations under the License.
 #define EIGEN_USE_GPU
 
 #if GOOGLE_CUDA
-#include "third_party/cub/device/device_radix_sort.cuh"
-#include "third_party/cub/device/device_reduce.cuh"
-#include "third_party/cub/iterator/constant_input_iterator.cuh"
-#include "third_party/cub/thread/thread_operators.cuh"
+#include "third_party/gpus/cuda/include/cub/cub.cuh"
 #elif TENSORFLOW_USE_ROCM
 #include "external/rocprim_archive/hipcub/include/hipcub/hipcub.hpp"
 #endif
diff --git a/tensorflow/core/kernels/histogram_op_gpu.cu.cc b/tensorflow/core/kernels/histogram_op_gpu.cu.cc
index 5f35adccba3..f82d8d0efbd 100644
--- a/tensorflow/core/kernels/histogram_op_gpu.cu.cc
+++ b/tensorflow/core/kernels/histogram_op_gpu.cu.cc
@@ -19,7 +19,7 @@ limitations under the License.
 
 #include "third_party/eigen3/unsupported/Eigen/CXX11/Tensor"
 #if GOOGLE_CUDA
-#include "third_party/cub/device/device_histogram.cuh"
+#include "third_party/gpus/cuda/include/cub/cub.cuh"
 #elif TENSORFLOW_USE_ROCM
 #include "external/rocprim_archive/hipcub/include/hipcub/hipcub.hpp"
 #endif
diff --git a/tensorflow/core/kernels/non_max_suppression_op.cu.cc b/tensorflow/core/kernels/non_max_suppression_op.cu.cc
index 1749a66579b..da6f0174119 100644
--- a/tensorflow/core/kernels/non_max_suppression_op.cu.cc
+++ b/tensorflow/core/kernels/non_max_suppression_op.cu.cc
@@ -19,9 +19,7 @@ limitations under the License.
 
 #include "absl/strings/str_cat.h"
 #include "third_party/eigen3/unsupported/Eigen/CXX11/Tensor"
-#include "third_party/cub/device/device_radix_sort.cuh"
-#include "third_party/cub/device/device_segmented_radix_sort.cuh"
-#include "third_party/cub/device/device_select.cuh"
+#include "third_party/gpus/cuda/include/cub/cub.cuh"
 #include "tensorflow/core/framework/numeric_types.h"
 #include "tensorflow/core/framework/op_kernel.h"
 #include "tensorflow/core/framework/tensor_types.h"
diff --git a/tensorflow/core/kernels/reduction_gpu_kernels.cu.h b/tensorflow/core/kernels/reduction_gpu_kernels.cu.h
index 7024d62a53e..62a9faa45d7 100644
--- a/tensorflow/core/kernels/reduction_gpu_kernels.cu.h
+++ b/tensorflow/core/kernels/reduction_gpu_kernels.cu.h
@@ -24,12 +24,7 @@ limitations under the License.
 
 #include "third_party/eigen3/unsupported/Eigen/CXX11/Tensor"
 #if GOOGLE_CUDA
-#include "third_party/cub/device/device_reduce.cuh"
-#include "third_party/cub/device/device_segmented_reduce.cuh"
-#include "third_party/cub/iterator/counting_input_iterator.cuh"
-#include "third_party/cub/iterator/transform_input_iterator.cuh"
-#include "third_party/cub/warp/warp_reduce.cuh"
-#include "third_party/gpus/cuda/include/cuComplex.h"
+#include "third_party/gpus/cuda/include/cub/cub.cuh"
 #elif TENSORFLOW_USE_ROCM
 #include "external/rocprim_archive/hipcub/include/hipcub/hipcub.hpp"
 #endif
diff --git a/tensorflow/core/kernels/scan_ops_gpu.h b/tensorflow/core/kernels/scan_ops_gpu.h
index eaa9360a5b7..1665d998ca6 100644
--- a/tensorflow/core/kernels/scan_ops_gpu.h
+++ b/tensorflow/core/kernels/scan_ops_gpu.h
@@ -25,11 +25,7 @@ limitations under the License.
 #endif  // CUDA_VERSION >= 9000
 
 #if GOOGLE_CUDA
-#include "third_party/cub/block/block_load.cuh"
-#include "third_party/cub/block/block_scan.cuh"
-#include "third_party/cub/block/block_store.cuh"
-#include "third_party/cub/iterator/counting_input_iterator.cuh"
-#include "third_party/cub/iterator/transform_input_iterator.cuh"
+#include "third_party/gpus/cuda/include/cub/cub.cuh"
 #include "third_party/gpus/cuda/include/cuComplex.h"
 #elif TENSORFLOW_USE_ROCM
 #include "external/rocprim_archive/hipcub/include/hipcub/hipcub.hpp"
diff --git a/tensorflow/core/kernels/topk_op_gpu.h b/tensorflow/core/kernels/topk_op_gpu.h
index 12717ca11fe..a48a86ca89d 100644
--- a/tensorflow/core/kernels/topk_op_gpu.h
+++ b/tensorflow/core/kernels/topk_op_gpu.h
@@ -23,9 +23,7 @@ limitations under the License.
 #include <vector>
 
 #include "third_party/eigen3/unsupported/Eigen/CXX11/Tensor"
-#include "third_party/cub/device/device_segmented_radix_sort.cuh"
-#include "third_party/cub/iterator/counting_input_iterator.cuh"
-#include "third_party/cub/iterator/transform_input_iterator.cuh"
+#include "third_party/gpus/cuda/include/cub/cub.cuh"
 #include "tensorflow/core/framework/op_kernel.h"
 #include "tensorflow/core/framework/register_types.h"
 #include "tensorflow/core/framework/tensor.h"
diff --git a/tensorflow/core/kernels/where_op_gpu.cu.h b/tensorflow/core/kernels/where_op_gpu.cu.h
index 8c228d60ebb..e49de52fcfd 100644
--- a/tensorflow/core/kernels/where_op_gpu.cu.h
+++ b/tensorflow/core/kernels/where_op_gpu.cu.h
@@ -22,10 +22,7 @@ limitations under the License.
 
 #include "third_party/eigen3/unsupported/Eigen/CXX11/Tensor"
 #if GOOGLE_CUDA
-#include "third_party/cub/device/device_reduce.cuh"
-#include "third_party/cub/device/device_select.cuh"
-#include "third_party/cub/iterator/counting_input_iterator.cuh"
-#include "third_party/cub/iterator/transform_input_iterator.cuh"
+#include "third_party/gpus/cuda/include/cub/cub.cuh"
 #elif TENSORFLOW_USE_ROCM
 #include "external/rocprim_archive/hipcub/include/hipcub/hipcub.hpp"
 #endif
@@ -246,6 +243,8 @@ class WhereOutputIterator {
     return *(ptr_ + (valid ? (NDIM * n) : 0));
   }
 
+ EIGEN_DEVICE_FUNC EIGEN_STRONG_INLINE operator int64*(){ return ptr_; }
+
  private:
   int64* ptr_;
   const Eigen::DenseIndex max_row_;
diff --git a/tensorflow/core/lib/bfloat16/bfloat16.h b/tensorflow/core/lib/bfloat16/bfloat16.h
index a133f7e0f17..c2c5681417d 100644
--- a/tensorflow/core/lib/bfloat16/bfloat16.h
+++ b/tensorflow/core/lib/bfloat16/bfloat16.h
@@ -18,6 +18,7 @@ limitations under the License.
 
 #include <cmath>
 #include <complex>
+#include <cstdint>
 
 #include "tensorflow/core/platform/byte_order.h"
 
diff --git a/tensorflow/core/lib/core/coding.h b/tensorflow/core/lib/core/coding.h
index bfab80dd007..33deb95faf7 100644
--- a/tensorflow/core/lib/core/coding.h
+++ b/tensorflow/core/lib/core/coding.h
@@ -24,6 +24,7 @@ limitations under the License.
 #include "tensorflow/core/lib/core/raw_coding.h"
 #include "tensorflow/core/lib/core/stringpiece.h"
 #include "tensorflow/core/platform/types.h"
+#include <cstdint>
 
 namespace tensorflow {
 namespace core {
diff --git a/tensorflow/core/lib/gif/gif_io.cc b/tensorflow/core/lib/gif/gif_io.cc
index dc5406920a4..ae2f0b373d4 100644
--- a/tensorflow/core/lib/gif/gif_io.cc
+++ b/tensorflow/core/lib/gif/gif_io.cc
@@ -17,6 +17,8 @@ limitations under the License.
 
 #include "tensorflow/core/lib/gif/gif_io.h"
 #include <algorithm>
+#include <cstdint>
+#include <cstring>
 #include "tensorflow/core/lib/gtl/cleanup.h"
 #include "tensorflow/core/lib/strings/strcat.h"
 #include "tensorflow/core/platform/gif.h"
diff --git a/tensorflow/core/platform/posix/port.cc b/tensorflow/core/platform/posix/port.cc
index 47f4abae3bb..f70d5ea5e24 100644
--- a/tensorflow/core/platform/posix/port.cc
+++ b/tensorflow/core/platform/posix/port.cc
@@ -37,6 +37,7 @@ limitations under the License.
 #include <stdlib.h>
 #include <string.h>
 #include <unistd.h>
+#include <cstdint>
 #ifdef TF_USE_SNAPPY
 #include "snappy.h"
 #endif
diff --git a/tensorflow/examples/speech_commands/input_data.py b/tensorflow/examples/speech_commands/input_data.py
index 2bb48e01b79..4ad31f64fc7 100644
--- a/tensorflow/examples/speech_commands/input_data.py
+++ b/tensorflow/examples/speech_commands/input_data.py
@@ -29,7 +29,6 @@ import tarfile
 
 import numpy as np
 from six.moves import urllib
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 
 from tensorflow.contrib.framework.python.ops import audio_ops as contrib_audio
@@ -545,7 +544,7 @@ class AudioProcessor(object):
     pick_deterministically = (mode != 'training')
     # Use the processing graph we created earlier to repeatedly to generate the
     # final output sample data we'll use in training.
-    for i in xrange(offset, offset + sample_count):
+    for i in range(offset, offset + sample_count):
       # Pick which audio sample to use.
       if how_many == -1 or pick_deterministically:
         sample_index = i
diff --git a/tensorflow/examples/speech_commands/train.py b/tensorflow/examples/speech_commands/train.py
index 446e351cb81..54b01e9f2a7 100644
--- a/tensorflow/examples/speech_commands/train.py
+++ b/tensorflow/examples/speech_commands/train.py
@@ -75,7 +75,6 @@ import os.path
 import sys
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 
 import input_data
@@ -206,7 +205,7 @@ def main(_):
 
   # Training loop.
   training_steps_max = np.sum(training_steps_list)
-  for training_step in xrange(start_step, training_steps_max + 1):
+  for training_step in range(start_step, training_steps_max + 1):
     # Figure out what the current learning rate is.
     training_steps_sum = 0
     for i in range(len(training_steps_list)):
@@ -243,7 +242,7 @@ def main(_):
       set_size = audio_processor.set_size('validation')
       total_accuracy = 0
       total_conf_matrix = None
-      for i in xrange(0, set_size, FLAGS.batch_size):
+      for i in range(0, set_size, FLAGS.batch_size):
         validation_fingerprints, validation_ground_truth = (
             audio_processor.get_data(FLAGS.batch_size, i, model_settings, 0.0,
                                      0.0, 0, 'validation', sess))
@@ -280,7 +279,7 @@ def main(_):
   tf.compat.v1.logging.info('set_size=%d', set_size)
   total_accuracy = 0
   total_conf_matrix = None
-  for i in xrange(0, set_size, FLAGS.batch_size):
+  for i in range(0, set_size, FLAGS.batch_size):
     test_fingerprints, test_ground_truth = audio_processor.get_data(
         FLAGS.batch_size, i, model_settings, 0.0, 0.0, 0, 'testing', sess)
     test_accuracy, conf_matrix = sess.run(
diff --git a/tensorflow/examples/tutorials/mnist/fully_connected_feed.py b/tensorflow/examples/tutorials/mnist/fully_connected_feed.py
index 8eb57100058..455312644e5 100644
--- a/tensorflow/examples/tutorials/mnist/fully_connected_feed.py
+++ b/tensorflow/examples/tutorials/mnist/fully_connected_feed.py
@@ -24,7 +24,6 @@ import os
 import sys
 import time
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 
 from tensorflow.examples.tutorials.mnist import input_data
@@ -103,7 +102,7 @@ def do_eval(sess,
   true_count = 0  # Counts the number of correct predictions.
   steps_per_epoch = data_set.num_examples // FLAGS.batch_size
   num_examples = steps_per_epoch * FLAGS.batch_size
-  for step in xrange(steps_per_epoch):
+  for step in range(steps_per_epoch):
     feed_dict = fill_feed_dict(data_set,
                                images_placeholder,
                                labels_placeholder)
@@ -160,7 +159,7 @@ def run_training():
     sess.run(init)
 
     # Start the training loop.
-    for step in xrange(FLAGS.max_steps):
+    for step in range(FLAGS.max_steps):
       start_time = time.time()
 
       # Fill a feed dictionary with the actual set of images and labels
diff --git a/tensorflow/examples/tutorials/mnist/input_data.py b/tensorflow/examples/tutorials/mnist/input_data.py
index fa148ae3e6f..5f3e57cdca3 100644
--- a/tensorflow/examples/tutorials/mnist/input_data.py
+++ b/tensorflow/examples/tutorials/mnist/input_data.py
@@ -25,7 +25,6 @@ import tempfile
 
 import numpy
 from six.moves import urllib
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 from tensorflow.contrib.learn.python.learn.datasets.mnist import read_data_sets
 # pylint: enable=unused-import
diff --git a/tensorflow/examples/tutorials/word2vec/word2vec_basic.py b/tensorflow/examples/tutorials/word2vec/word2vec_basic.py
index 5eef590c1dd..af05a1e6992 100644
--- a/tensorflow/examples/tutorials/word2vec/word2vec_basic.py
+++ b/tensorflow/examples/tutorials/word2vec/word2vec_basic.py
@@ -30,7 +30,6 @@ import zipfile
 
 import numpy as np
 from six.moves import urllib
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 
 from tensorflow.contrib.tensorboard.plugins import projector
@@ -254,7 +253,7 @@ def word2vec_basic(log_dir):
     print('Initialized')
 
     average_loss = 0
-    for step in xrange(num_steps):
+    for step in range(num_steps):
       batch_inputs, batch_labels = generate_batch(batch_size, num_skips,
                                                   skip_window)
       feed_dict = {train_inputs: batch_inputs, train_labels: batch_labels}
@@ -289,12 +288,12 @@ def word2vec_basic(log_dir):
       # Note that this is expensive (~20% slowdown if computed every 500 steps)
       if step % 10000 == 0:
         sim = similarity.eval()
-        for i in xrange(valid_size):
+        for i in range(valid_size):
           valid_word = reverse_dictionary[valid_examples[i]]
           top_k = 8  # number of nearest neighbors
           nearest = (-sim[i, :]).argsort()[1:top_k + 1]
           log_str = 'Nearest to %s:' % valid_word
-          for k in xrange(top_k):
+          for k in range(top_k):
             close_word = reverse_dictionary[nearest[k]]
             log_str = '%s %s,' % (log_str, close_word)
           print(log_str)
@@ -302,7 +301,7 @@ def word2vec_basic(log_dir):
 
     # Write corresponding labels for the embeddings.
     with open(log_dir + '/metadata.tsv', 'w') as f:
-      for i in xrange(vocabulary_size):
+      for i in range(vocabulary_size):
         f.write(reverse_dictionary[i] + '\n')
 
     # Save the model for checkpoints.
@@ -347,7 +346,7 @@ def word2vec_basic(log_dir):
         perplexity=30, n_components=2, init='pca', n_iter=5000, method='exact')
     plot_only = 500
     low_dim_embs = tsne.fit_transform(final_embeddings[:plot_only, :])
-    labels = [reverse_dictionary[i] for i in xrange(plot_only)]
+    labels = [reverse_dictionary[i] for i in range(plot_only)]
     plot_with_labels(low_dim_embs, labels, os.path.join(gettempdir(),
                                                         'tsne.png'))
 
diff --git a/tensorflow/lite/kernels/internal/spectrogram.cc b/tensorflow/lite/kernels/internal/spectrogram.cc
index 784e4bc99ef..0d016e27b3f 100644
--- a/tensorflow/lite/kernels/internal/spectrogram.cc
+++ b/tensorflow/lite/kernels/internal/spectrogram.cc
@@ -17,6 +17,7 @@ limitations under the License.
 
 #include <assert.h>
 #include <math.h>
+#include <cstdint>
 
 #include "third_party/fft2d/fft.h"
 
diff --git a/tensorflow/lite/testing/generate_examples_lib.py b/tensorflow/lite/testing/generate_examples_lib.py
index 292d7169e61..0264803da52 100644
--- a/tensorflow/lite/testing/generate_examples_lib.py
+++ b/tensorflow/lite/testing/generate_examples_lib.py
@@ -41,7 +41,6 @@ import traceback
 import zipfile
 import numpy as np
 from six import StringIO
-from six.moves import xrange
 
 # TODO(aselle): Disable GPU for now
 os.environ["CUDA_VISIBLE_DEVICES"] = "-1"
@@ -3404,7 +3403,7 @@ def make_lstm_tests(options):
     input_vec_size = parameters["input_vec_size"]
     num_cells = parameters["num_cells"]
     inputs_after_split = []
-    for i in xrange(time_step_size):
+    for i in range(time_step_size):
       one_timestamp_input = tf.placeholder(
           dtype=parameters["dtype"],
           name="split_{}".format(i),
@@ -3437,7 +3436,7 @@ def make_lstm_tests(options):
     time_step_size = parameters["time_step_size"]
     input_vec_size = parameters["input_vec_size"]
     input_values = []
-    for _ in xrange(time_step_size):
+    for _ in range(time_step_size):
       tensor_data = create_tensor_data(parameters["dtype"],
                                        [num_batchs, input_vec_size], 0, 1)
       input_values.append(tensor_data)
diff --git a/tensorflow/python/autograph/impl/conversion.py b/tensorflow/python/autograph/impl/conversion.py
index a0275725ad1..780f3b9cc5f 100644
--- a/tensorflow/python/autograph/impl/conversion.py
+++ b/tensorflow/python/autograph/impl/conversion.py
@@ -20,7 +20,7 @@ from __future__ import print_function
 
 import collections
 import functools
-import imp
+import importlib
 import sys
 import threading
 import types
@@ -606,7 +606,7 @@ def _add_self_references(namespace, autograph_module):
   if ag_internal is None:
     # Craft a module that exposes parts of the external API as well as certain
     # internal modules.
-    ag_internal = imp.new_module('autograph')
+    ag_internal = importlib.import_module('autograph')
     ag_internal.__dict__.update(autograph_module.__dict__)
     ag_internal.ConversionOptions = converter.ConversionOptions
     ag_internal.STD = converter.STANDARD_OPTIONS
diff --git a/tensorflow/python/autograph/operators/py_builtins.py b/tensorflow/python/autograph/operators/py_builtins.py
index cd5f69bbce2..40d88fe18f7 100644
--- a/tensorflow/python/autograph/operators/py_builtins.py
+++ b/tensorflow/python/autograph/operators/py_builtins.py
@@ -359,7 +359,7 @@ def _py_zip(*iterables):
 SUPPORTED_BUILTINS = (abs, float, int, len, print, range, enumerate, zip)
 
 if six.PY2:
-  SUPPORTED_BUILTINS += (xrange,)
+  SUPPORTED_BUILTINS += (range,)
 
 BUILTIN_FUINCTIONS_MAP = {
     'abs': abs_,
@@ -369,7 +369,7 @@ BUILTIN_FUINCTIONS_MAP = {
     'print': print_,
     'range': range_,
     # TODO(mdan): This might make more sense as tf.data.range.
-    'xrange': range_,
+    'range': range_,
     'enumerate': enumerate_,
     'zip': zip_,
 }
diff --git a/tensorflow/python/autograph/pyct/compiler.py b/tensorflow/python/autograph/pyct/compiler.py
index 297f28cfeaf..4b0ac777b2b 100644
--- a/tensorflow/python/autograph/pyct/compiler.py
+++ b/tensorflow/python/autograph/pyct/compiler.py
@@ -25,7 +25,7 @@ from __future__ import print_function
 
 # TODO(mdan): Use six for compatibility here.
 import atexit
-import imp
+import importlib.util
 import os
 import tempfile
 
@@ -101,7 +101,10 @@ def source_to_entity(source, delete_on_exit):
 
   if delete_on_exit and ag_logging.get_verbosity() < 3:
     atexit.register(lambda: os.remove(f.name))
-  return imp.load_source(module_name, f.name), f.name
+  spec = importlib.util.spec_from_file_location(module_name, f.name)
+  module = importlib.util.module_from_spec(spec)
+  spec.loader.exec_module(module)
+  return module, f.name
 
 
 # TODO(mdan): Rename: ast_to_entity
diff --git a/tensorflow/python/autograph/pyct/inspect_utils.py b/tensorflow/python/autograph/pyct/inspect_utils.py
index 47c52d2e8bb..aacccdfeda9 100644
--- a/tensorflow/python/autograph/pyct/inspect_utils.py
+++ b/tensorflow/python/autograph/pyct/inspect_utils.py
@@ -54,7 +54,7 @@ SPECIAL_BUILTINS = {
 }
 
 if six.PY2:
-  SPECIAL_BUILTINS['xrange'] = xrange
+  SPECIAL_BUILTINS['range'] = range
 
 
 def islambda(f):
diff --git a/tensorflow/python/autograph/utils/testing.py b/tensorflow/python/autograph/utils/testing.py
index a59642c9577..7435a1f9018 100644
--- a/tensorflow/python/autograph/utils/testing.py
+++ b/tensorflow/python/autograph/utils/testing.py
@@ -18,7 +18,7 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-import imp
+import importlib
 
 from tensorflow.python.framework import ops
 from tensorflow.python.ops import gen_math_ops
@@ -27,7 +27,7 @@ from tensorflow.python.ops import math_ops
 
 def fake_tf():
   """Creates a fake module that looks like TensorFlow, for testing."""
-  mod = imp.new_module('tensorflow')
+  mod = importlib.import_module('tensorflow')
   mod_contents = {}
   mod_contents.update(gen_math_ops.__dict__)
   mod_contents.update(math_ops.__dict__)
diff --git a/tensorflow/python/client/session_benchmark.py b/tensorflow/python/client/session_benchmark.py
index 130b05ac4ce..8bca11b1fac 100644
--- a/tensorflow/python/client/session_benchmark.py
+++ b/tensorflow/python/client/session_benchmark.py
@@ -22,7 +22,6 @@ import time
 
 import numpy as np
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 from tensorflow.python.client import session
 from tensorflow.python.framework import dtypes
 from tensorflow.python.framework import ops
@@ -57,7 +56,7 @@ class SessionBenchmark(test.Benchmark):
       no_op = array_ops.identity(p).op
       with session.Session(target) as sess:
         sess.run(no_op, feed_dict={p: feed_val})  # Warm-up run.
-        for _ in xrange(iters):
+        for _ in range(iters):
           start_time = time.time()
           sess.run(no_op, feed_dict={p: feed_val})
           end_time = time.time()
@@ -85,7 +84,7 @@ class SessionBenchmark(test.Benchmark):
       with session.Session(target) as sess:
         sess.run(v.initializer)
         sess.run(v)  # Warm-up run.
-        for _ in xrange(iters):
+        for _ in range(iters):
           start_time = time.time()
           sess.run(v)
           end_time = time.time()
@@ -114,7 +113,7 @@ class SessionBenchmark(test.Benchmark):
         sess.run(v.initializer)
         runner = sess.make_callable(v)
         runner()  # Warm-up run.
-        for _ in xrange(iters):
+        for _ in range(iters):
           start_time = time.time()
           runner()
           end_time = time.time()
@@ -140,7 +139,7 @@ class SessionBenchmark(test.Benchmark):
       with session.Session(target) as sess:
         sess.run(v.initializer)
         sess.run(v.op)  # Warm-up run.
-        for _ in xrange(iters):
+        for _ in range(iters):
           start_time = time.time()
           sess.run(v.op)
           end_time = time.time()
@@ -167,7 +166,7 @@ class SessionBenchmark(test.Benchmark):
         sess.run(v.initializer)
         runner = sess.make_callable(v.op)
         runner()  # Warm-up run.
-        for _ in xrange(iters):
+        for _ in range(iters):
           start_time = time.time()
           runner()
           end_time = time.time()
